stages:
  - build
  - test
  - package
  - acceptance
  #- deploy

build:
  stage: build
  image: node:14-alpine
  script:
    - npm ci --only=production
    - echo "Compiling the code..."
    - echo "Compile complete."
  artifacts:
    paths:
      - node_modules/
      - server.js

unit-test:
  stage: test
  image: node:14-alpine
  before_script:
    - npm install
  script:
    - npm test
    
build docker image:
  stage: package
  image: docker
  services:
    - docker:dind
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    - docker build -t $CI_REGISTRY_IMAGE
    - docker push $CI_REGISTRY_IMAGE

curl api testing:
  stage: acceptance
  image: docker
  services:
    - docker:dind
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    - docker run -d -p 3000:3000 $CI_REGISTRY_IMAGE
    - apk add curl
    - curl http://localhost:3000/state | grep "UP"
#deploy:
#  stage: deploy
#  environment: production
#  script:
#    - echo "Deploying application..."
#    - echo "Application successfully deployed."
